package com.pfc.app.nbff;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;

public class ActividadMapa extends MapActivity{

	public static Context cntxt;
	private static int mTipoVista;
	private static int mRadioAmigos;
	private static int mTiempoActualizacion;
	private static String mUsuario;
	private static String mPassword;

	private static MapView mMapa;
	private static MapController mControlMapa;
	public static List<Overlay> mMapOverlays;
	
	
	private static MyLocationOverlay mMiPosicion;
	private static String URLPosicionar = "http://aperezba.dyndns.org.168.1.5:9080/webService/VisiblesAction.action?parametroJSON=";
	private boolean primeraLlamada = true;

	

	/**
	 * Variable donde se guarda la localización del lugar que se va añadir al
	 * mapa.
	 */
	private GeoPoint mGeoLugar;
	private static Integer lat = -1;
	private static Integer lon = -1;
	private static Double	sitio;
	private static Double	lugar;
	private static String msgExt = new String();
	public static int numeroUsuariosApintar;
	public static String idUsuario;


	private Location mLocalAnterior50m;
	private DeviceLocationListener mLocationListener;
	private LocationManager mLocationControl;

	
	//private static int nvBat;
	static String nomUsuario;
	static String apUsuario;
	static String contrUsuario;
	static String emailUsuario;
	static String nickNameUsuario;
	public static LinearLayout ll;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// Le damos una vista que mostrar al programa
		
		
		
		setContentView(R.layout.layout_mapa);
		cntxt = getBaseContext();
		mTipoVista = 0;
		//nvBat = nivelBateria();
		//Log.i("BateriaInicio", "And the battery level is... " + nvBat + "%");
		
	
		Log.i("Mapita", "hemos entrao aquí y hemos obtenido el contexto");

		// Guardamos el usuario y password además de las opciones de usuario
		// para usar en el mapa.
		nomUsuario = getIntent().getStringExtra("nombre");
		apUsuario = getIntent().getStringExtra("apellidos");
		contrUsuario = getIntent().getStringExtra("pass");
		emailUsuario = getIntent().getStringExtra("email");
		nickNameUsuario = getIntent().getStringExtra("nick");
		idUsuario = getIntent().getStringExtra("idUser");

		// Recogemos los datos de perfil del usuario
		String perfil = devuelvePerfil(conectarPerfil((cntxt),idUsuario));
		
		nickNameUsuario = desencriptaNickPerfil(perfil);
		apUsuario = desencriptaApellidosPerfil(perfil);
		emailUsuario = desencriptaEmailPerfil(perfil);
		nomUsuario = desencriptaNombrePerfil(perfil);

		
		
		Log.i("RecogidaDeDatos", "el usuario cuyo id es: " + idUsuario + " se llama: " + nomUsuario + " " + apUsuario + " email: " + emailUsuario);
		Log.i("RecogidaDeDatos", " nick y contraseña: " + nickNameUsuario + " y  " + contrUsuario);
		
		final ImageButton botonVista = (ImageButton) findViewById(R.id.ImageButtonVistaMapa);
		
		mMapa = (MapView) findViewById(R.id.mapa);
		

		// Creamos el controlador del mapa.
		mControlMapa = mMapa.getController();
		// Creamos los controles de zoom del mapa.
		mMapa.setBuiltInZoomControls(true);
		// Configuramos la vista del mapa.
		if (mTipoVista == 0)
			mMapa.setSatellite(false);
		else
			mMapa.setSatellite(true);
		// Configuramos el zoom por defecto
		mControlMapa.setZoom(12);
		
		Log.i("Mapita", "hemos entrao aquí y hemos hecho cosas de mapas");
		
		
		// Mostramos un diálogo si hay solicitudes de amistad pendientes de contestar
		// muestraDialogoSolicitudesPendientes();

			
		
		// Creamos el overlay de posición del usuario.
		mMiPosicion = new MyLocationOverlay(this, mMapa);
		// Activamos la localización del usuario si la hay
		mMiPosicion.enableMyLocation();
		
		
		
		Log.i("Mapita", "hemos entrao aquí y seguimos haciendo cosas de mapas");
		
		// Movemos el mapa a la localización del usuario y lanzamos el servicio de localización de amigos si no estaba activo
		mMiPosicion.runOnFirstFix(new Runnable() {
			public void run() {
				mGeoLugar = mMiPosicion.getMyLocation();
				mControlMapa.animateTo(mGeoLugar);
				mControlMapa.setZoom(15);
				lat = mGeoLugar.getLatitudeE6();
				lon = mGeoLugar.getLongitudeE6();
				String cadConex = URLPosicionar;
				cadConex = URLPosicionar.concat(idUsuario +"x"+lat.intValue()+"x"+lon.intValue());
				Log.i("URLFormada", cadConex);
				enviar(cadConex);
				if (!Servicio.activo){
					try{
						
						Servicio.setMainActivity();
						
					}catch(Exception e){
						Log.i("error", "error en el servicio");
					}
				}
			}
		});

		mLocationListener = new DeviceLocationListener();
		mLocationControl = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
		mLocationControl.requestLocationUpdates("gps", 30000, 50,mLocationListener);
		
		
		Log.i("Mapita", "hemos entrao aquí y hacemos cosas de overlays");
	
		// Creamos la variable de control de overlays.
		mMapOverlays = mMapa.getOverlays();

		// Añadimos mi posición al control de overlays.
		mMapOverlays.add(mMiPosicion);
		
		Log.i("Mapita", "hemos entrao aquí y hacemos más cosas de overlays");
		
		
		SharedPreferences settings = getSharedPreferences("perfil", MODE_PRIVATE);
		String deNotifica = settings.getString("deNotificaciones", "false");
		
		Log.i("Mapita", "hemos entrao aquí y hacemos cosas de shared preferences de esas: " + deNotifica);
		
		// Si se ha cargado el mapa pulsando la notificación, pintamos nuevamente los amigos en el mapa
		if (deNotifica.equals("true")){
			numeroUsuariosApintar = settings.getInt("numeroUsuariosPintar", -1);
			Log.i("deNotificaciones", "El fallo no es de numero de usuarios: " + numeroUsuariosApintar);
			String usuariosApintar = settings.getString("usuariosApintar",null);
			Log.i("deNotificaciones", "El fallo no es de usuarios apintar: " + usuariosApintar);
			String posicionUsuarios [][]= desencriptaUsuarios(usuariosApintar);
			mControlMapa.setZoom(15);
			if(numeroUsuariosApintar>0){
				Log.i("deNotificaciones", "El número de usuarios a pintar obtenido es: " + posicionUsuarios.length);
				Log.i("deNotificaciones", "El número de usuarios a pintar obtenido por getIntent es: " + numeroUsuariosApintar);
				dibujarAmigosSinNotifica(posicionUsuarios,numeroUsuariosApintar);
			}
			
		}
		
		// configuramos el evento onClick de los botones
		botonVista.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				showDialog(0);
			}
		});
				
	}

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

	/**
	 * Metodo que implementa el evento de menu creado.
	 * 
	 * @return Devuelve si ha podido crearse o no el menu.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		boolean result = super.onCreateOptionsMenu(menu);
		// Añadimos al menú la búsqueda de amigos(id=0)
		menu.add(0, 0, 0, R.string.menuBuscarAmigos).setIcon(
				R.drawable.creep004);
		// Añadimos al menú el ver las peticiones de amistad pendientes (id=1)
		menu.add(0, 1, 0, R.string.menuPeticionesAmistad).setIcon(R.drawable.add_friend);
		// Añadimos al menú la salida de la aplicación (id=2)
		menu.add(0, 2, 0, R.string.menuSalir).setIcon(
				R.drawable.shutdown);
		// Añadimos al menú las opciones (id=3)
		menu.add(0, 3, 0, R.string.menuOpciones).setIcon(R.drawable.settings_48);
		// Añadimos al menú la lectura de mensajes (id=4)
		menu.add(0,4,0, R.string.menuLeerMensajes).setIcon(R.drawable.charlas);
		return result;
	}

	/**
	 * Metodo que implementa el evento de pulsacion en uno de los elementos del
	 * menu.
	 * 
	 * @return Devuelve verdadero si el evento es tratado en este metodo, falso
	 *         en caso contrario.
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		// Si se ha pulsado el botón de buscar amigos.
		case 0:
			SharedPreferences sett = getSharedPreferences("perfil", MODE_PRIVATE);
			SharedPreferences.Editor edita = sett.edit();
			edita.putString("deNotificaciones", "false");
			edita.commit();
			Log.i("onOptionsItemSelected", "commit realizado");
			String cadena = conectarListaUsuarios(cntxt);
			if (cadena.equals(""))
				return true;
			Log.i("onOptionsItemSelected", "búsqueda realizada con éxito");
			String cadAux = buscaAmigos(cadena);
			Log.i("onOptionsItemSelected", "número de usuarios a pintar: " + numeroUsuariosApintar);
			String usu[][] = desencriptaUsuarios(cadAux);
			if(numeroUsuariosApintar>0){
				Log.i("onOptionsItemSelected", "desencriptamos");
				dibujarAmigos(usu, numeroUsuariosApintar);
				Log.i("onOptionsItemSelected", "dibujamos");
			}else
				Toast.makeText(cntxt, R.string.textoNOAmigos, Toast.LENGTH_LONG).show();
			
			return true;

			// Si se ha pulsado el botónde añadir amigo.
		case 1:
			final String pet[][] = consultarPeticionesAmistad(idUsuario);
			if (pet[0][0].equals("-1")){
				Log.i("BotónSoclicitudesPendientes", "no hay solicitudes pendientes.");
				Toast.makeText(cntxt, R.string.noHayPeticiones, Toast.LENGTH_LONG).show();
			}else
				muestraDialogoSolicitudesPendientes(pet);
			return true;

			// Si se ha pulsado el botón de salir.
		case 2:
			finish();
			return true;
			// Si se ha pulsado el botón de opciones.
		case 3:
			Intent iMapa = new Intent(this, ActividadLista.class);
			// Pasamos a la actividad opciones el radio y el usuario que estamos
			// usando.
			iMapa.putExtra("radio", mRadioAmigos);
			iMapa.putExtra("usuario", mUsuario);
			iMapa.putExtra("password", mPassword);
			iMapa.putExtra("tiempo", mTiempoActualizacion);
			iMapa.putExtra("vista", mTipoVista);
			iMapa.putExtra("idUser", idUsuario);
			startActivityForResult(iMapa, 0);
			return true;
		case 4:
			muestraDialogoMensajes(idUsuario);
			return true;
		}

		return super.onOptionsItemSelected(item);
	}



	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {

		// Si la actividad de las opciones ha devuelto datos.
		if (data != null) {
			String pass = data.getStringExtra("password");
			mRadioAmigos = data.getIntExtra("radio", -1);
			mTiempoActualizacion = data.getIntExtra("tiempo", -1);
			int resetLug = data.getIntExtra("reseteaLugares", 0);
			int resetAmig = data.getIntExtra("reseteaAmigos", 0);
		}
		super.onActivityResult(requestCode, resultCode, data);
	}

	protected Dialog onCreateDialog(int id) {

		final Dialog d = new Dialog(ActividadMapa.this);
		d.setCanceledOnTouchOutside(true);
		d.setTitle(R.string.tituloDialogoVistaMapa);
		d.setContentView(R.layout.interfaz_dialogo_vista_mapa);
		
		Log.i("DialogMapa", "creado dialog del tipo de vista");
		
		final Spinner spinador = (Spinner) d.findViewById(R.id.SpinnerVistaMapa);
		final ArrayAdapter<CharSequence> adaptadorSpinner = ArrayAdapter.createFromResource(d.getContext(), R.array.vistasMapa,
						android.R.layout.simple_spinner_item);
		
		Log.i("DialogMapa", "creado array adapter del tipo de vista");
		
		adaptadorSpinner.setDropDownViewResource(android.R.layout.simple_dropdown_item_1line);
		Log.i("DialogMapa", "setdropdown hecho");
		spinador.setAdapter(adaptadorSpinner);
		Log.i("DialogMapa", "setadapter hecho");
		spinador.setSelection(mTipoVista);
		Log.i("DialogMapa", "setselection hecho");

		spinador.setOnItemSelectedListener(new OnItemSelectedListener() {

			public void onItemSelected(AdapterView<?> arg0, View arg1,int arg2, long arg3) {

				if (!primeraLlamada) {
					if (arg3 == 0) {
						mMapa.setSatellite(false);
					} else if (arg3 == 1) {
						mMapa.setSatellite(true);
					}
					d.dismiss();
				} else
					primeraLlamada = false;

			}

			public void onNothingSelected(AdapterView<?> arg0) {
				d.dismiss();
			}

		});

		return d;
	}


	private class DeviceLocationListener implements LocationListener {

		/**
		 * Este método se usaría si quisiéramos hacer alguna operacion cuando el
		 * estado del GPS cambia.
		 */
		public void onStatusChanged(String provider, int status, Bundle extras) {

		}

		/**
		 * Este método se usaría si quisiéramos hacer alguna operacion cuando se
		 * activa el GPS.
		 */
		public void onProviderEnabled(String provider) {

		}

		/**
		 * Este método se usaría si quisiéramos hacer alguna operacion cuando se
		 * desactiva el GPS.
		 */
		public void onProviderDisabled(String provider) {

		}

		/**
		 * Método que recoge el evento de cambio de localización.
		 * 
		 * @param location
		 *            La nueva localización enviada por el GPS.
		 */
		public void onLocationChanged(Location location) {

			if (mLocalAnterior50m == null) {
				mLocalAnterior50m = location;
			} else if (mLocalAnterior50m.distanceTo(location) >= 50) {
				String aux = URLPosicionar;
				
				sitio = location.getLatitude()*1E6;
				lugar = location.getLongitude()*1E6;
				mGeoLugar = new GeoPoint(sitio.intValue(), lugar.intValue());				
				mControlMapa.animateTo(mGeoLugar);
				mControlMapa.setZoom(15);
				mControlMapa.animateTo(new GeoPoint(sitio.intValue(), lugar.intValue()));
				aux = URLPosicionar.concat(idUsuario + "x" + sitio.intValue() + "x" + lugar.intValue());
				enviar (aux);
				Log.i("URLFormada", aux);
				
				mLocalAnterior50m = location;
			}
		}
	}

	private void muestraDialogoAmigoNuevo() {

		// Creamos el constructor de diálogos.
		AlertDialog.Builder constructor = new AlertDialog.Builder(cntxt);
		constructor.setTitle(R.string.escribaNomAmigo);
		constructor.setCancelable(true);

		final EditText editAmigo = new EditText(cntxt);
		constructor.setView(editAmigo);
		// Creamos el evento de pulsación del botón aceptar.
		constructor.setPositiveButton(R.string.aceptar,
				new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int which) {

						if (editAmigo.getText().length() > 0) {
							int resultado = 0;
							// Devuelve 1 si la operación se ha realizado
							// correctamente, -4 si el nombre de amigo es igual
							// al nuestro,
							// -5 si el amigo ya existe, en otro caso se ha
							// producido un error en la operacion.
							switch (resultado) {
							case 1:
								Toast
										.makeText(cntxt,
												R.string.amigoExito,
												Toast.LENGTH_SHORT).show();
								break;
							case -4:
								Toast.makeText(cntxt,
										R.string.nomAmigoIgual,
										Toast.LENGTH_SHORT).show();
								break;
							case -5:
								Toast.makeText(cntxt,
										R.string.amigoYaExiste,
										Toast.LENGTH_SHORT).show();
								break;
							default:
								Toast.makeText(cntxt,
										R.string.falloOperacion,
										Toast.LENGTH_SHORT).show();
								break;
							}
							dialog.dismiss();
						} else {
							Toast.makeText(cntxt,
									"Escribe un nombre de usuario",
									Toast.LENGTH_SHORT).show();
						}
					}
				});
		// Creamos el evento de pulsación del botón cancelar.
		constructor.setNegativeButton(R.string.cancelar,
				new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int which) {

						dialog.dismiss();
					}
				});
		// Llamamos al método creador del constructor y directamente lo
		// mostramos por pantalla.
		constructor.create().show();
	}

	public static String makeRequest(String path, Map<Integer, List<Integer>> params) throws Exception {

		DefaultHttpClient httpclient = new DefaultHttpClient();
		HttpPost httpost = new HttpPost(path);
		Iterator iter = params.entrySet().iterator();

		JSONObject holder = new JSONObject();

		while (iter.hasNext()) {
			Map.Entry<Integer, List<Integer>> pairs = (Map.Entry<Integer, List<Integer>>) iter
					.next();
			String key = (String) pairs.getKey().toString();
			Map m = (Map) pairs.getValue();

			JSONObject data = new JSONObject();
			Iterator iter2 = m.entrySet().iterator();
			while (iter2.hasNext()) {
				Map.Entry pairs2 = (Map.Entry) iter2.next();
				data.put((String) pairs2.getKey(), (String) pairs2.getValue());
			}
			holder.put(key, data);
		}

		StringEntity se = new StringEntity(holder.toString());
		httpost.setEntity(se);
		httpost.setHeader("Accept", "application/json");
		httpost.setHeader("Content-type", "application/json");

		ResponseHandler responseHandler = new BasicResponseHandler();
		AbstractHttpClient response = httpclient.execute(httpost,
				responseHandler);
		return response.toString();
	}
	public static String conectarListaUsuarios (Context context){
		final String CadConectar = "http://aperezba.dyndns.org:9080/webService/ListaUsuariosVisiblesAction.action?parametroJSON=";
		
		InputStream is = null;
		String result = "";
		String aux;
		
		
		if (lat.intValue()==-1 || lon.intValue()==-1 ){
			Toast.makeText(cntxt, R.string.textoNOposicion, Toast.LENGTH_LONG).show();
		}else{
			aux = CadConectar.concat(idUsuario + "x" + lat.intValue() + "x" + lon.intValue());
			Log.i("CadenaConexión", "creamos las variables y la url de conexión" + aux);
		
			try{
			    HttpClient httpclient = new DefaultHttpClient();
			    HttpPost httppost = new HttpPost(aux);
			    HttpResponse response = httpclient.execute(httppost);
			    HttpEntity entity = response.getEntity();
			    is = entity.getContent();
			    /*if (cnt.equals(cntxt))
			    	Toast.makeText(cntxt, "Buscando amigos, espere por favor...", Toast.LENGTH_LONG).show();*/
			
			}catch(Exception e){
			    Log.e("log_tag", "Error in http connection "+e.toString());
			    //Toast.makeText(cnt, "Error in http connection "+e.toString(), Toast.LENGTH_LONG).show();
			}
			
			//convert response to string
			try{
			    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
			    StringBuilder sb = new StringBuilder();
			    String line = null;
			    while ((line = reader.readLine()) != null) {
			            sb.append(line + "\n");
			    }
			    is.close();
			    result=sb.toString();
			    /*if (cnt.equals(cntxt))
			    	Toast.makeText(cntxt, "Realizando comprobaciones...", Toast.LENGTH_LONG).show();*/
			}catch(Exception e){
			    Log.e("log_tag", "Error converting result "+e.toString());
			    //Toast.makeText(cnt, "Error converting result "+e.toString(), Toast.LENGTH_LONG).show();
			}
		   	Log.i("CadenaConexión", "el resultado es " + result);
		}return result;
		
	}
		
	
	
	
	public static String conectar (Context cnt){
    	
	   	final String CadConectar = "http://aperezba.dyndns.org:9080/webService/VisiblesAction.action?parametroJSON=";
				
		InputStream is = null;
		String result = "";
		String aux;
		
		
		if (lat.intValue()==-1 || lon.intValue()==-1 ){
			Toast.makeText(cntxt, R.string.textoNOposicion, Toast.LENGTH_LONG).show();
		}else{
			aux = CadConectar.concat(idUsuario + "x" + lat.intValue() + "x" + lon.intValue());
			Log.i("CadenaConexión", "creamos las variables y la url de conexión" + aux);
		
			try{
			    HttpClient httpclient = new DefaultHttpClient();
			    HttpPost httppost = new HttpPost(aux);
			    HttpResponse response = httpclient.execute(httppost);
			    HttpEntity entity = response.getEntity();
			    is = entity.getContent();
			    /*if (cnt.equals(cntxt))
			    	Toast.makeText(cntxt, "Buscando amigos, espere por favor...", Toast.LENGTH_LONG).show();*/
			
			}catch(Exception e){
			    Log.e("log_tag", "Error in http connection "+e.toString());
			    //Toast.makeText(cnt, "Error in http connection "+e.toString(), Toast.LENGTH_LONG).show();
			}
			
			//convert response to string
			try{
			    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
			    StringBuilder sb = new StringBuilder();
			    String line = null;
			    while ((line = reader.readLine()) != null) {
			            sb.append(line + "\n");
			    }
			    is.close();
			    result=sb.toString();
			    /*if (cnt.equals(cntxt))
			    	Toast.makeText(cntxt, "Realizando comprobaciones...", Toast.LENGTH_LONG).show();*/
			}catch(Exception e){
			    Log.e("log_tag", "Error converting result "+e.toString());
			    //Toast.makeText(cnt, "Error converting result "+e.toString(), Toast.LENGTH_LONG).show();
			}
		   	Log.i("CadenaConexión", "el resultado es " + result);
		}return result;
		
	}
	
	/*
	private int nivelBateria(){
		mBatInfoReceiver = new BroadcastReceiver(){
	    @Override
	    public void onReceive(Context arg0, Intent intent) {

	      nvBat = intent.getIntExtra("level", -1);
	      Log.i("BateriaBateria", "Y la batería la tenemos a un nivel de... " + String.valueOf(nvBat) + "%");
	     
	    }
	  };
	  
	  this.registerReceiver(mBatInfoReceiver, new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
	  return nvBat;
	}*/
	
	
	public static String devuelvePerfil(String conexion) {
		
		String ret = null;
		try{
			
			JSONObject json = (JSONObject) new JSONTokener(conexion).nextValue();
			Log.i("infoJSON", "Objeto JSON creado");
	    	JSONArray nameArray = json.names();
	    	Log.i("infoJSON", "obtenemos nombres");
	    	JSONArray valArray = json.toJSONArray(nameArray);
	    	Log.i("infoJSON", "lo pasamos a array");
	    	
    		ret = new String (valArray.getString(0));
    		Log.i("infoJSON", "Lo convertimos a String");
	    		
		}catch(JSONException e){
	            Log.e("log_tag", "Error parsing data ()"+e.toString());
	            //Toast.makeText(cntxt, "Error parsing data "+e.toString(), Toast.LENGTH_LONG).show();
		}
		catch (NullPointerException exc){
			Log.i("Excepción", "Error" + exc);
		}
       
		return ret;
		
	}
	
	public static String desencriptaNickPerfil(String cadenaPerfil){
		
		String nick = null;
		String aux [] = new String [2];
		String datosAmigo [] = new String [4];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoNick", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoNick", aux[0]);
	         	Log.i("TratamientoNick", aux[1]);
	         	
	         	datosAmigo = aux[0].split("x");

	         	
	         	nick = datosAmigo[2];
	         	Log.i("TratamientoNick", "nick: " + nick);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaNick", "falló el split");
     	 	}
	     	
     	return nick;
		
		
	}
	
	public static String desencriptaApellidosPerfil(String cadenaPerfil){
		
		String apellidos = null;
		String aux [] = new String [2];
		String datosAmigo [] = new String [4];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoApellidos", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoApellidos", aux[0]);
	         	Log.i("TratamientoApellidos", aux[1]);
	         	
	         	datosAmigo = aux[0].split("x");

	         	
	         	apellidos = datosAmigo[1];
	         	Log.i("TratamientoApellidos", "Apellidos: " + apellidos);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaApellidos", "falló el split");
     	 	}
	     	
     	return apellidos;
		
		
	}

	public static String desencriptaNombrePerfil(String cadenaPerfil){
	
		String nom = null;
		String aux [] = new String [2];
		String datosAmigo [] = new String [4];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
	 	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
	 	
	 	 	try{
	     		
	         	Log.i("TratamientoNombre", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoNombre", aux[0]);
	         	Log.i("TratamientoNombre", aux[1]);
	         	
	         	datosAmigo = aux[0].split("x");
	
	         	
	         	nom = datosAmigo[0];
	         	Log.i("TratamientoNombre", "Nombre: " + nom);
	
	 	 	}catch(Exception e){
	 	 		Log.i("ErrorDesencriptaNombre", "falló el split");
	 	 	}
	     	
	 	return nom;
	}
	
	public static String desencriptaSexoPerfil(String cadenaPerfil){
		
	
		String sexo = null;
		String aux [] = new String [2];
		String preferencias [] = new String [8];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoSexo", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoSexo", aux[0]);
	         	Log.i("TratamientoSexo", aux[1]);
	         	
	         	preferencias = aux[1].split("xyx");

	         	
	         	sexo = preferencias[0];
	         	
	         	switch (Integer.parseInt(sexo)){
	         		case 1:
	         			sexo = "Hombre";
	         			break;
	         		case 2:
	         			sexo = "Mujer";
	         			break;
	         	}
	         	Log.i("TratamientoSexo", "Sexo: " + sexo);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaSexo", "falló el split");
     	 	}
	     	
     	return sexo;
		
	}
	
	public static String desencriptaAlturaPerfil(String cadenaPerfil){
		
		
		String altura = null;
		String aux [] = new String [2];
		String preferencias [] = new String [8];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoAltura", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoAltura", aux[0]);
	         	Log.i("TratamientoAltura", aux[1]);
	         	
	         	preferencias = aux[1].split("xyx");

	         	
	         	altura = preferencias[1];
	         	
	         	switch (Integer.parseInt(altura)){
	         		case 1:
	         			altura = "menos de 1.50 m";
	         			break;
	         		case 2:
	         			altura = "entre 1.51 y 1.60 m";
	         			break;
	         		case 3:
	         			altura = "entre 1.61 y 1.65 m";
	         			break;
	         		case 4:
	         			altura = "entre 1.66 y 1.70 m";
	         			break;
	         		case 5:
	         			altura = "entre 1.71 y 1.75 m";
	         			break;
	         		case 6:
	         			altura = "entre 1.76 y 1.80 m";
	         			break;
	         		case 7:
	         			altura = "entre 1.81 y 1.85 m";
	         			break;
	         		case 8:
	         			altura = "entre 1.86 y 1.90 m";
	         			break;
	         		case 9:
	         			altura = "más de 1.91 m";
	         			break;
	         	}
	         	Log.i("TratamientoAltura", "altura: " + altura);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaAltura", "falló el split");
     	 	}
	     	
     	return altura;
	}
	
	public static String desencriptaPesoPerfil(String cadenaPerfil){
		
		
		String peso = null;
		String aux [] = new String [2];
		String preferencias [] = new String [8];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoAltura", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoPeso", aux[0]);
	         	Log.i("TratamientoPeso", aux[1]);
	         	
	         	preferencias = aux[1].split("xyx");

	         	
	         	peso = preferencias[2];
	         	
	         	switch (Integer.parseInt(peso)){
	         		case 1:
	         			peso = "entre 40 y 50 kg";
	         			break;
	         		case 2:
	         			peso = "entre 51 y 60 kg";
	         			break;
	         		case 3:
	         			peso = "entre 61 y 70 kg";
	         			break;
	         		case 4:
	         			peso = "entre 71 y 80 kg";
	         			break;
	         		case 5:
	         			peso = "entre 81 y 90 kg";
	         			break;
	         		case 6:
	         			peso = "entre 91 y 100 kg";
	         			break;
	         		case 7:
	         			peso = "entre 101 y 110 kg";
	         			break;
	         		case 8:
	         			peso = "más de 111 kg";
	         			break;
	         	}
	         	Log.i("TratamientoPeso", "Peso: " + peso);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaPeso", "falló el split");
     	 	}
	     	
     	return peso;
	}
	
public static String desencriptaEdadPerfil(String cadenaPerfil){
		
		
		String edad = null;
		String aux [] = new String [2];
		String preferencias [] = new String [8];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoEdad", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoEdad", aux[0]);
	         	Log.i("TratamientoEdad", aux[1]);
	         	
	         	preferencias = aux[1].split("xyx");

	         	
	         	edad = preferencias[4];
	         	
	         	switch (Integer.parseInt(edad)){
	         		case 1:
	         			edad = "entre 18 y 22 años";
	         			break;
	         		case 2:
	         			edad = "entre 23 y 25 años";
	         			break;
	         		case 3:
	         			edad = "entre 26 y 29 años";
	         			break;
	         		case 4:
	         			edad = "entre 30 y 35 años";
	         			break;
	         		case 5:
	         			edad = "entre 36 y 40 años";
	         			break;
	         		case 6:
	         			edad = "entre 41 y 46 años";
	         			break;
	         		case 7:
	         			edad = "entre 47 y 50 años";
	         			break;
	         		case 8:
	         			edad = "entre 51 y 55 años";
	         			break;
	         		case 9:
	         			edad = "más de 56 años";
	         			break;
	         	}
	         	Log.i("TratamientoEdad", "Edad: " + edad);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaEdad", "falló el split");
     	 	}
	     	
     	return edad;
	}

	public static String desencriptaComplexionPerfil(String cadenaPerfil){
	
	
	String complexion = null;
	String aux [] = new String [2];
	String preferencias [] = new String [8];
	
	
	//Colocamos los datos en un array para sacarlos más cómodamente
	
	Log.i("log_tag", cadenaPerfil);
 	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
 	
 	 	try{
     		
         	Log.i("TratamientoComplexion", "tamaño cadena: " + cadenaPerfil.length());
         	
     		aux = cadenaPerfil.split("XX");
     		Log.i("TratamientoComplexion", aux[0]);
         	Log.i("TratamientoComplexion", aux[1]);
         	
         	preferencias = aux[1].split("xyx");

         	
         	complexion = preferencias[3];
         	
         	switch (Integer.parseInt(complexion)){
         		case 1:
         			complexion = "Delgado/a";
         			break;
         		case 2:
         			complexion = "Normal";
         			break;
         		case 3:
         			complexion = "En forma";
         			break;
         		case 4:
         			complexion = "Atlético/a";
         			break;
         		case 5:
         			complexion = "Bien definido/a";
         			break;
         		case 6:
         			complexion = "Con unos kilos de más";
         			break;
         		case 7:
         			complexion = "Robusto";
         			break;
         		case 8:
         			complexion = "Mujer con curvas";
         			break;
         	}
         	Log.i("TratamientoComplexion", "Complexión: " + complexion);

 	 	}catch(Exception e){
 	 		Log.i("ErrorDesencriptaAltura", "falló el split");
 	 	}
     	
 	return complexion;
}
	
	
public static String desencriptaEstudiosPerfil(String cadenaPerfil){
		
		
		String estudios = null;
		String aux [] = new String [2];
		String preferencias [] = new String [8];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoEstudios", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoEstudios", aux[0]);
	         	Log.i("TratamientoEstudios", aux[1]);
	         	
	         	preferencias = aux[1].split("xyx");

	         	//Cambiar cuando se suba el webService
	         	estudios = preferencias[7];
	         	
	         	switch (Integer.parseInt(estudios)){
	         		case 1:
	         			estudios = "ESO";
	         			break;
	         		case 2:
	         			estudios = "Bachillerato";
	         			break;
	         		case 3:
	         			estudios = "Ciclo Formativo";
	         			break;
	         		case 4:
	         			estudios = "Licenciado, ingeniero o diplomado";
	         			break;
	         		case 5:
	         			estudios = "Doctorado";
	         			break;

	         	}
	         	Log.i("TratamientoEstudios", "Estudios: " + estudios);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaAltura", "falló el split");
     	 	}
	     	
     	return estudios;
	}


	
	public static String desencriptaEmailPerfil(String cadenaPerfil){
		
		String emilio = null;
		String aux [] = new String [2];
		String datosAmigo [] = new String [4];
		
		
		//Colocamos los datos en un array para sacarlos más cómodamente
		
		Log.i("log_tag", cadenaPerfil);
     	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
     	
     	 	try{
	     		
	         	Log.i("TratamientoEmail", "tamaño cadena: " + cadenaPerfil.length());
	         	
	     		aux = cadenaPerfil.split("XX");
	     		Log.i("TratamientoEmail", aux[0]);
	         	Log.i("TratamientoEmail", aux[1]);
	         	
	         	datosAmigo = aux[0].split("x");

	         	
	         	emilio = datosAmigo[4];
	         	Log.i("TratamientoEmail", "E-mail: " + emilio);

     	 	}catch(Exception e){
     	 		Log.i("ErrorDesencriptaEmail", "falló el split");
     	 	}
	     	
     	return emilio;
		
		
	}
	
public static String desencriptaSaludoPerfil(String cadenaPerfil){
	
	String saludo = null;
	String aux [] = new String [2];

	String preferencias [] = new String [8];
	
	
	//Colocamos los datos en un array para sacarlos más cómodamente
	
	Log.i("log_tag", cadenaPerfil);
 	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
 	
 	 	try{
     		
         	Log.i("TratamientoSaludo", "tamaño cadena: " + cadenaPerfil.length());
         	
     		aux = cadenaPerfil.split("XX");
     		Log.i("TratamientoSaludo", aux[0]);
         	Log.i("TratamientoSaludo", aux[1]);
         	

         	preferencias = aux[1].split("xyx");
         	
         	saludo = preferencias[6];
         	Log.i("TratamientoSaludo", "Saludo: " + saludo);

 	 	}catch(Exception e){
 	 		Log.i("ErrorDesencriptaSaludo", "falló el split");
 	 	}
     	
 	return saludo;
	
	}

public static String desencriptaDescripcionPerfil(String cadenaPerfil){
	
	String descrip = null;
	String aux [] = new String [2];
	String preferencias [] = new String [8];
	
	
	//Colocamos los datos en un array para sacarlos más cómodamente
	
	Log.i("log_tag", cadenaPerfil);
 	Log.i("log", "tamaño cadena: " + cadenaPerfil.length());
 	
 	 	try{
     		
         	Log.i("TratamientoDescrip", "tamaño cadena: " + cadenaPerfil.length());
         	
     		aux = cadenaPerfil.split("XX");
     		Log.i("TratamientoDescrip", aux[0]);
         	Log.i("TratamientoDescrip", aux[1]);
         	
         	preferencias = aux[1].split("xyx");
         	
         	descrip = preferencias[5];
         	Log.i("TratamientoDescip", "Descripción: " + descrip);

 	 	}catch(Exception e){
 	 		Log.i("ErrorDesencriptaDescrip", "falló el split");
 	 	}
     	
 	return descrip;
	
	
}

	public static String conectarPerfil (Context contexto, String iduser ){
		
		final String CadConectar = "http://aperezba.dyndns.org:9080/webService/DatosUsuariosAction.action?parametroJSON=" + iduser;
		
		InputStream is = null;
		String result = "";
	
		Log.i("CadenaConexión", "creamos las variables y la url de conexión" + CadConectar);
	
		try{
		    HttpClient httpclient = new DefaultHttpClient();
		    HttpPost httppost = new HttpPost(CadConectar);
		    HttpResponse response = httpclient.execute(httppost);
		    HttpEntity entity = response.getEntity();
		    is = entity.getContent();
		
		}catch(Exception e){
		    Log.e("log_tag", "Error in http connection "+e.toString());
		}
		
		//convert response to string
		try{
		    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
		    StringBuilder sb = new StringBuilder();
		    String line = null;
		    while ((line = reader.readLine()) != null) {
		            sb.append(line + "\n");
		    }
		    is.close();
		    result=sb.toString();
		    
		}catch(Exception e){
		    Log.e("log_tag", "Error converting result "+e);
		}
	   	Log.i("CadenaConexión", "el resultado es " + result);
		return result;
	}
	
	
	
	
	public static String buscaAmigos(String conexion) {
		
		
		try{
			
			JSONObject json = (JSONObject) new JSONTokener(conexion).nextValue();
			Log.i("infoJSON", "Objeto JSON creado");
	    	JSONArray nameArray = json.names();
	    	Log.i("infoJSON", "obtenemos nombres");
	    	JSONArray valArray = json.toJSONArray(nameArray);
	    	Log.i("infoJSON", "lo pasamos a array");
	    	
	    	//Log.i ("BateriaBateria(BuscaAmigos)", "el nivel de batería es... " + nvBat);
	    	
		    //if (nvBat > 10){
	    		msgExt = new String (valArray.getString(0));
	    		Log.i("infoJSON", "Lo convertimos a String");
	    		
         	/*}else{
         			cntxt.wait(300);
	         		muestraDialogoBateria();
	        }*/
         	
	        
		}catch(JSONException e){
	            Log.e("JSONError", "Error parsing data "+e.toString());
	            //Toast.makeText(cntxt, "Error parsing data "+e.toString(), Toast.LENGTH_LONG).show();
		}
		catch (NullPointerException exc){
			Log.i("Excepción", "Error: " + exc);
		}
       
		return msgExt;
	}
	
	public static String[][] desencriptaUsuarios(String msg){
		String posicionesUsuarios [][] = new String[256][3];
		String aux [] = new String [256];
		int inicio=3;
		int indice=0;
		//Colocamos los usuarios en un array para sacarlos más cómodamente
		int i = 0;
		Log.i("log_tag", msg);
     	Log.i("log", "tamaño cadena: " + msg.length());
     	indice = msg.indexOf(",");
     	Log.i("log", "índice inicial: " + indice);
     	
     	
     	
     	//Comprobamos si hay algún posible amigo.
     	if(msg.length()>2){
     		
	     	if (indice == -1){
	     		Log.i("TratamientoInicialyFinal", msg);
	         	Log.i("TratamientoInicialyFinal", "tamaño cadena: " + msg.length());
	         	
	     		aux[i] = msg.substring(msg.indexOf("\"")+1, msg.indexOf("]")-1);
	         	Log.i("TratamientoInicialyFinal", aux[i]);
	         	inicio = inicio + aux[i].length();
	         	Log.i("TratamientoInicialyFinal","inicio: "+inicio);
	         	msg=msg.substring(inicio,msg.length());
	         	
	         	posicionesUsuarios[i] = aux[i].split("x");
	         	Log.i("log_Usuarios", "id: " + posicionesUsuarios[i][0] + " lat: " + posicionesUsuarios[i][1] + " long: " + posicionesUsuarios[i][2]);
	         	i++;
	         	Log.i("logRestanteCadena", "contador=" + i + " resto de la cadena " + msg);
		         
	     	}else if (indice!=0){	         		
	     	
	         	aux[i] = msg.substring(msg.indexOf("\"")+1, msg.indexOf(",")-1);
	         	Log.i("log", aux[i]);
	         	inicio = inicio + aux[i].length();
	         	Log.i("log", "inicio: " + inicio);
	         	msg=msg.substring(inicio+1,msg.length());
	         	Log.i("log", "corte de cadena bien hecho: " + msg);
	         	posicionesUsuarios[i] = aux[i].split("x");
	         	Log.i("log_Usuarios", "id: " + posicionesUsuarios[i][0] + " lat: " + posicionesUsuarios[i][1] + " long: " + posicionesUsuarios[i][2]);
	         	
	         	indice = msg.indexOf(",");
	         	Log.i("log", msg);
	         	i++;
	         	
	            while (indice !=-1){
	            	
	            	
	            
	            	Log.i("log_tag", msg);
	            	Log.i("log", "tamaño cadena: " + msg.length());
	            	aux[i] = msg.substring(msg.indexOf("\"")+1, msg.indexOf(",")-1);
	            	Log.i("log", aux[i]);
	            	inicio = aux[i].length();
	            	Log.i("log","inicio: "+inicio);
	            	msg=msg.substring(inicio+3,msg.length());
	            	
	            	posicionesUsuarios[i] = aux[i].split("x");
	             	Log.i("log_Usuarios", "id: " + posicionesUsuarios[i][0] + " lat: " + posicionesUsuarios[i][1] + " long: " + posicionesUsuarios[i][2]);
	             	
	            	Log.i("log", msg);
	            	indice = msg.indexOf(",");
	            	i++;
	            }
	            
	            Log.i("TratamientoFinal", msg);
	         	Log.i("TratamientoFinal", "tamaño cadena: " + msg.length());
	         	aux[i] = msg.substring(msg.indexOf("\"")+1, msg.indexOf("]")-1);
	         	Log.i("TratamientoFinal", aux[i]);
	         	inicio = aux[i].length();
	         	Log.i("TratamientoFinal","inicio: "+inicio);
	         	msg=msg.substring(inicio,msg.length());
	         	
	         	posicionesUsuarios[i] = aux[i].split("x");
	         	Log.i("log_Usuarios", "id: " + posicionesUsuarios[i][0] + " lat: " + posicionesUsuarios[i][1] + " long: " + posicionesUsuarios[i][2]);
	         	i++;
	         	Log.i("logRestanteCadena", "contador=" + i + " resto de la cadena " + msg);
	     	} 	
     	} 	//Una vez colocados los usuarios en la tabla los colocamos en el mapa si hay usuarios y si la batería no está por debajo del 10%
     	
     	numeroUsuariosApintar = i;
     	return posicionesUsuarios;
     	
	}
		
	public static void dibujarAmigos (String arrayUsuarios[][], int numUsuarios){
		
		GeoPoint puntoAmigo;
		
		if(numUsuarios>0){
			String tmp [] = new String[numUsuarios];
	     	for ( int j = 0 ; j< numUsuarios ; j++){
	     		
	     		
	     		tmp = arrayUsuarios[j];
	     		puntoAmigo = new GeoPoint(Integer.parseInt(tmp[1]), Integer.parseInt(tmp[2]));
	     		
	         	Log.i("logPosicionarUsuarios", "id: " + tmp[0] + " lat: " + puntoAmigo.getLatitudeE6() + " long: " + puntoAmigo.getLongitudeE6());
	         	
	         	
	         	String perfilAmigo = devuelvePerfil(conectarPerfil((cntxt),tmp[0]));
	         
	         	AmigoOverlay amigo = new AmigoOverlay(mMapa,puntoAmigo, desencriptaNickPerfil(perfilAmigo), tmp[0]);
	         	
	         	try{
	         	
	         		if (!tmp.equals(null)){
			     		mMapOverlays.add(amigo);
			         	Log.i("logPosicionarUsuarios", "Añadidos los usuarios al overlay");
			         	mMapa.postInvalidate();
			         	Log.i("logPosicionarUsuarios", "Actualizado mapa");
			         	if (Servicio.i>1){
				         	Intent notificaciones = new Intent (cntxt, Notificaciones.class);
				         	notificaciones.putExtra("usuariosApintar", msgExt);
				         	notificaciones.putExtra("numeroUsuariosPintar", numeroUsuariosApintar);
				         	Log.i("logPosicionarUsuarios", "Creada notificación");
				            //Especificamos que acción realizar si pulsamos sobre la notificación
				            notificaciones.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				            
				         	cntxt.startActivity(notificaciones);
			         	}
		         	        	
		         	Log.i("logPosicionarUsuarios", "Añadidos los overlays y los views al mapa");
	         		}
	         		
	         	}catch ( Exception e){
	         		Log.i("ExcepcionlogPosicionarUsuarios", "Excepción pintando en el mapa: " + e);
	         	}
	         	
	 	         	
	 	
	 	
	     	
	     	}
		}else{
			Toast.makeText(cntxt, "Actualmente no tiene amigos lo suficientemente cerca", Toast.LENGTH_LONG).show();
		}
		
		
	}
	
	

	private static void dibujarAmigosSinNotifica (String arrayUsuarios[][], int numUsuarios){
		
		GeoPoint puntoAmigoB;
		
		if(numUsuarios>0){
		
			String tmp [] = new String[numUsuarios];
	     	for ( int j = 0 ; j< numUsuarios ; j++){
	     		
	     		tmp = arrayUsuarios[j];
	     		puntoAmigoB = new GeoPoint(Integer.parseInt(tmp[1]), Integer.parseInt(tmp[2]));
	     		
	         	Log.i("logPosicionarUsuarios", "id: " + tmp[0] + " lat: " + puntoAmigoB.getLatitudeE6() + " long: " + puntoAmigoB.getLongitudeE6());

	         	String perfilAmigoB = devuelvePerfil(conectarPerfil((cntxt),tmp[0]));
	         	
	         	AmigoOverlay amigoB = new AmigoOverlay(mMapa,puntoAmigoB, desencriptaNickPerfil(perfilAmigoB), tmp[0]);

	         	
	         	if (!tmp.equals(null)){
		     		mMapOverlays.add(amigoB);
		         	Log.i("logPosicionarUsuarios", "Añadidos los usuarios al overlay");
		         	mMapa.postInvalidate();
		         	Log.i("logPosicionarUsuarios", "Actualizado mapa");
		         	
		     	}
	     	}
	 	         	
	 	
	 	
	     	
		}
	}
	
	
	private static void muestraDialogoBateria(){
		// Creamos el constructor de diálogos.
		AlertDialog.Builder constructor = new AlertDialog.Builder(cntxt);
		constructor.setTitle("La Batería está críticamente baja");
		constructor.setCancelable(true);

		final TextView textBateria = new TextView(cntxt);
		textBateria.append("La batería está demasiado baja, ¿desea continuar de todas maneras?");
		textBateria.measure(15, 15);
		constructor.setView(textBateria);
		
		// Creamos el evento de pulsación del botón aceptar.
		constructor.setPositiveButton(R.string.continuar,
				new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int which) {

						//mMapOverlays.add(mLugaresOverlay);
						mMapa.postInvalidate();
						Intent notificaciones = new Intent (cntxt, Notificaciones.class);
						notificaciones.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
						cntxt.startActivity(notificaciones);
						dialog.dismiss();
						
					}
				});
		// Creamos el evento de pulsación del botón cancelar.
		constructor.setNegativeButton(R.string.cancelar,
				new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int which) {

						dialog.dismiss();
					}
				});
		// Llamamos al método creador del constructor y directamente lo
		// mostramos por pantalla.
		constructor.create().show();
		
		
	}
	
	
	public void enviar(String cadConexion){
    	 
    	 				
    	 HttpClient httpclient = new DefaultHttpClient();
    	//Seteamos nuestro servidor que recibirá las variables Post
    	 Log.i("envio posicion", "por aki por aki");
    	 
    	 HttpPost httppost = new HttpPost(cadConexion);
    	 Log.i("envio posicion", "por aki por aki2");
    	 

		try {
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
		    Log.i("envio posicion", "por aki por aki3");
		
    	//agregamos datos a mi lista
    	    nameValuePairs.add(new BasicNameValuePair("Tu_variable", "0.0"));
    	    Log.i("envio posicion", "por aki por aki4");
    	
    	      
    	//Contruimos el pack de datos
    	    httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
    	    Log.i("envio posicion", "por aki por aki5");
    	
    	         
    	          

    	//Ejecutamos la instrucciones de httpPost
    	       
    	    HttpResponse response = httpclient.execute(httppost);
    	    Log.i("envio posicion", "por aki por aki6: ");
    	  
    	      
    	    } catch (ClientProtocolException e) {
    	    	Log.i("fallito pixa", "eso");
    	    } catch (IOException e) {
    	    	Log.i("fallito pixa", "lo otro");
    	     }
    	 
     }
	
	public static String esAmigo(String idUser ,String idUserPosible){

		final String CadConectar = "http://aperezba.dyndns.org:9080/webService/EsAmigoAction.action?parametroJSON=" + idUser+"x"+idUserPosible;
		
		InputStream is = null;
		String result = "";
	
		Log.i("CadenaConexión", "creamos las variables y la url de conexión" + CadConectar);
	
		try{
		    HttpClient httpclient = new DefaultHttpClient();
		    HttpPost httppost = new HttpPost(CadConectar);
		    HttpResponse response = httpclient.execute(httppost);
		    HttpEntity entity = response.getEntity();
		    is = entity.getContent();
		
		}catch(Exception e){
		    Log.e("log_tag", "Error en la conexión http: "+e.toString());
		}
		
		//convert response to string
		try{
		    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
		    StringBuilder sb = new StringBuilder();
		    String line = null;
		    while ((line = reader.readLine()) != null) {
		            sb.append(line + "\n");
		    }
		    is.close();
		    result=sb.toString();
		    
		}catch(Exception e){
		    Log.e("log_tag", "Error converting result "+e);
		}
	   	Log.i("CadenaConexión", "el resultado es " + result);
		
		
		String retEsAmigo = null;
		try{
			
			JSONObject json = (JSONObject) new JSONTokener(result).nextValue();
			Log.i("infoJSONEsAmigo", "Objeto JSON creado");
	    	JSONArray nameArray = json.names();
	    	Log.i("infoJSONEsAmigo", "obtenemos nombres");
	    	JSONArray valArray = json.toJSONArray(nameArray);
	    	Log.i("infoJSONEsAmigo", "lo pasamos a array");
	    	
    		retEsAmigo = new String (valArray.getString(0));
    		Log.i("infoJSONEsAmigo", "Lo convertimos a String");
	    		
		}catch(JSONException e){
	            Log.e("infoJSONEsAmigo", "Error parsing data: "+e.toString());
	            //Toast.makeText(cntxt, "Error parsing data "+e.toString(), Toast.LENGTH_LONG).show();
		}
		catch (NullPointerException exc){
			Log.i("Excepción", "Error" + exc);
		}
       
		return retEsAmigo;
	}
    
    public static String añadeAmigoId(String idUser, String idUserAmigo){
    	

		final String CadConexionAñadirAmigoId = "http://aperezba.dyndns.org:9080/webService/Add_Amigo_idAction.action?parametroJSON=" + idUser+"x"+idUserAmigo;
		
		InputStream is = null;
		String result = "";
	
		Log.i("CadenaConexión", "creamos las variables y la url de conexión" + CadConexionAñadirAmigoId);
	
		try{
		    HttpClient httpclient = new DefaultHttpClient();
		    HttpPost httppost = new HttpPost(CadConexionAñadirAmigoId);
		    HttpResponse response = httpclient.execute(httppost);
		    HttpEntity entity = response.getEntity();
		    is = entity.getContent();
		
		}catch(Exception e){
		    Log.e("log_tag", "Error en la conexión http: "+e.toString());
		}
		
		//convert response to string
		try{
		    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
		    StringBuilder sb = new StringBuilder();
		    String line = null;
		    while ((line = reader.readLine()) != null) {
		            sb.append(line + "\n");
		    }
		    is.close();
		    result=sb.toString();
		    
		}catch(Exception e){
		    Log.e("log_tag", "Error al convertir a cadena: "+e);
		}
	   	Log.i("CadenaConexión", "el resultado es " + result);
		
		
		String retAñadido = null;
		try{
			
			JSONObject json = (JSONObject) new JSONTokener(result).nextValue();
			Log.i("infoJSONEsAmigo", "Objeto JSON creado");
	    	JSONArray nameArray = json.names();
	    	Log.i("infoJSONEsAmigo", "obtenemos nombres");
	    	JSONArray valArray = json.toJSONArray(nameArray);
	    	Log.i("infoJSONEsAmigo", "lo pasamos a array");
	    	
    		retAñadido = new String (valArray.getString(0));
    		Log.i("infoJSONEsAmigo", "Lo convertimos a String");
	    		
		}catch(JSONException e){
	            Log.e("infoJSONEsAmigo", "Error parsing data: "+e.toString());
	            //Toast.makeText(cntxt, "Error parsing data "+e.toString(), Toast.LENGTH_LONG).show();
		}
		catch (NullPointerException exc){
			Log.i("Excepción", "Error" + exc);
		}
    	return retAñadido;

    }
    
    public static void enviaPeticionAmigoId(String idUser1, String idUser2){
    	
    	final String CadConexionAñadirAmigoId = "http://aperezba.dyndns.org:9080/webService/Add_Peticion_Amigo_idAction.action?parametroJSON=" + idUser1+"x"+idUser2;
		
    	HttpClient httpclient = new DefaultHttpClient();
    	//Seteamos nuestro servidor que recibirá las variables Post
    	 Log.i("envio posicion", "por aki por aki: "+ CadConexionAñadirAmigoId);
    	 
    	 HttpPost httppost = new HttpPost(CadConexionAñadirAmigoId);
    	 Log.i("envio posicion", "por aki por aki2");
    	 

		try {
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
		    Log.i("envio posicion", "por aki por aki3");
		
    	//agregamos datos a mi lista
    	    nameValuePairs.add(new BasicNameValuePair("Tu_variable", "0.0"));
    	    Log.i("envio posicion", "por aki por aki4");
    	
    	      
    	//Contruimos el pack de datos
    	    httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
    	    Log.i("envio posicion", "por aki por aki5");
    	
    	         
    	          

    	//Ejecutamos la instrucciones de httpPost
    	       
    	    HttpResponse response = httpclient.execute(httppost);
    	    Log.i("envio posicion", "por aki por aki6: " + response + " en human: " + response.toString());
    	  
    	      
    	    } catch (ClientProtocolException e) {
    	    	Log.i("fallito pixa", "eso");
    	    } catch (IOException e) {
    	    	Log.i("fallito pixa", "lo otro");
    	     }
    }
    
    
    public static String desconecta(String idUser){

		final String CadDesConectar = "http://aperezba.dyndns.org:9080/webService/LoggoutAction.action?parametroJSON=" + idUser;
		
		InputStream is = null;
		String result = "";
	
		Log.i("CadenaConexión", "creamos las variables y la url de conexión" + CadDesConectar);
	
		try{
		    HttpClient httpclient = new DefaultHttpClient();
		    HttpPost httppost = new HttpPost(CadDesConectar);
		    HttpResponse response = httpclient.execute(httppost);
		    HttpEntity entity = response.getEntity();
		    is = entity.getContent();
		
		}catch(Exception e){
		    Log.e("log_tag", "Error en la conexión http: "+e.toString());
		}
		
		//convert response to string
		try{
		    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
		    StringBuilder sb = new StringBuilder();
		    String line = null;
		    while ((line = reader.readLine()) != null) {
		            sb.append(line + "\n");
		    }
		    is.close();
		    result=sb.toString();
		    
		}catch(Exception e){
		    Log.e("log_tag", "Error converting result "+e);
		}
	   	Log.i("CadenaConexión", "el resultado es " + result);
		
		
		String retEsAmigo = null;
		try{
			
			JSONObject json = (JSONObject) new JSONTokener(result).nextValue();
			Log.i("infoJSONEsAmigo", "Objeto JSON creado");
	    	JSONArray nameArray = json.names();
	    	Log.i("infoJSONEsAmigo", "obtenemos nombres");
	    	JSONArray valArray = json.toJSONArray(nameArray);
	    	Log.i("infoJSONEsAmigo", "lo pasamos a array");
	    	
    		retEsAmigo = new String (valArray.getString(0));
    		Log.i("infoJSONEsAmigo", "Lo convertimos a String");
	    		
		}catch(JSONException e){
	            Log.e("infoJSONEsAmigo", "Error parsing data: "+e.toString());
	            //Toast.makeText(cntxt, "Error parsing data "+e.toString(), Toast.LENGTH_LONG).show();
		}
		catch (NullPointerException exc){
			Log.i("Excepción", "Error" + exc);
		}
       
		return retEsAmigo;
	}
    
    
    public static String [][] consultarPeticionesAmistad(String idU){
    	
    	
    	
    	final String URLconsultarPetic = "http://aperezba.dyndns.org:9080/webService/ConsultarPeticionesAction.action?parametroJSON=" + idU;
		
		InputStream is = null;
		String result = "";
	
		Log.i("CadenaConexión", "creamos las variables y la url de conexión" + URLconsultarPetic);
	
		try{
		    HttpClient httpclient = new DefaultHttpClient();
		    HttpPost httppost = new HttpPost(URLconsultarPetic);
		    HttpResponse response = httpclient.execute(httppost);
		    HttpEntity entity = response.getEntity();
		    is = entity.getContent();
		
		}catch(Exception e){
		    Log.e("log_tag", "Error en la conexión http: "+e.toString());
		}
		
		//convert response to string
		try{
		    BufferedReader reader = new BufferedReader(new InputStreamReader(is,"iso-8859-1"),8);
		    StringBuilder sb = new StringBuilder();
		    String line = null;
		    while ((line = reader.readLine()) != null) {
		            sb.append(line + "\n");
		    }
		    is.close();
		    result=sb.toString();
		    
		}catch(Exception e){
		    Log.e("log_tag", "Error converting result "+e);
		}
	   	Log.i("CadenaConexión", "el resultado es " + result);
		
		
		String ret = null;
		try{
			
			JSONObject json = (JSONObject) new JSONTokener(result).nextValue();
			Log.i("infoJSONEsAmigo", "Objeto JSON creado");
	    	JSONArray nameArray = json.names();
	    	Log.i("infoJSONEsAmigo", "obtenemos nombres");
	    	JSONArray valArray = json.toJSONArray(nameArray);
	    	Log.i("infoJSONEsAmigo", "lo pasamos a array");
	    	
    		ret = new String (valArray.getString(0));
    		Log.i("infoJSONEsAmigo", "Lo convertimos a String");
	    		
		}catch(JSONException e){
	            Log.e("infoJSONEsAmigo", "Error parsing data: "+e.toString());
	            //Toast.makeText(cntxt, "Error parsing data "+e.toString(), Toast.LENGTH_LONG).show();
		}
		catch (NullPointerException exc){
			Log.i("Excepción", "Error" + exc);
		}
       
		
		String peticionesAmigos [][] = new String[256][2];
		String aux [] = new String [256];
		int inicio=3;
		int indice=0;
		//Colocamos los usuarios en un array para sacarlos más cómodamente
		int i = 0;
		Log.i("log_tag", ret);
     	Log.i("log", "tamaño cadena: " + ret.length());
     	indice = ret.indexOf(",");
     	Log.i("log", "índice inicial: " + indice);
     	
     	
     	
     	//Comprobamos si hay alguna solicitud de amigo.
     	if(ret.length()>2){
     		
	     	if (indice == -1){
	     		Log.i("TratamientoInicialyFinal", ret);
	         	Log.i("TratamientoInicialyFinal", "tamaño cadena: " + ret.length());
	         	
	     		aux[i] = ret.substring(ret.indexOf("\"")+1, ret.indexOf("]")-1);
	         	Log.i("TratamientoInicialyFinal", aux[i]);
	         	inicio = inicio + aux[i].length();
	         	Log.i("TratamientoInicialyFinal","inicio: "+inicio);
	         	ret=ret.substring(inicio,ret.length());
	         	
	         	peticionesAmigos[0]= aux[0].split("x");
	         	peticionesAmigos[1][0] = "-1";
	         	peticionesAmigos[1][1] = "No hay solicitudes";
	         	peticionesAmigos[2][0] = "-1";
	         	peticionesAmigos[2][1] = "No hay solicitudes";
	         	peticionesAmigos[3][0] = "-1";
	         	peticionesAmigos[3][1] = "No hay solicitudes";
	         	peticionesAmigos[4][0] = "-1";
	         	peticionesAmigos[4][1] = "No hay solicitudes";

	         	Log.i("TratamientoInicialyFinal", "id: " + peticionesAmigos[i][0] + " mensaje: " + peticionesAmigos[i][1]);
	         	Log.i("TratamientoInicialyFinal", "id: " + peticionesAmigos[1][0] + " mensaje: " + peticionesAmigos[1][1]);
	         	Log.i("TratamientoInicialyFinal", "id: " + peticionesAmigos[2][0] + " mensaje: " + peticionesAmigos[2][1]);
	         	Log.i("TratamientoInicialyFinal", "id: " + peticionesAmigos[3][0] + " mensaje: " + peticionesAmigos[3][1]);
	         	Log.i("TratamientoInicialyFinal", "id: " + peticionesAmigos[4][0] + " mensaje: " + peticionesAmigos[4][1]);
	         	
	         	i++;
	         	Log.i("logRestanteCadena", "contador=" + i + " resto de la cadena " + ret);
		         
	     	}else if (indice!=0){	         		
	     	
	         	aux[i] = ret.substring(ret.indexOf("\"")+1, ret.indexOf(",")-1);
	         	Log.i("log", aux[i]);
	         	inicio = inicio + aux[i].length();
	         	Log.i("log", "inicio: " + inicio);
	         	ret=ret.substring(inicio+1,ret.length());
	         	Log.i("log", "corte de cadena bien hecho: " + ret);
	         	peticionesAmigos[i] = aux[i].split("x");
	         	Log.i("log_Usuarios", "id: " + peticionesAmigos[i][0] + " mensaje: " + peticionesAmigos[i][1]);
	         	
	         	indice = ret.indexOf(",");
	         	Log.i("log", ret);
	         	i++;
	         	
	            while (indice !=-1){
	            	
	            	
	            
	            	Log.i("log_tag", ret);
	            	Log.i("log", "tamaño cadena: " + ret.length());
	            	aux[i] = ret.substring(ret.indexOf("\"")+1, ret.indexOf(",")-1);
	            	Log.i("log", aux[i]);
	            	inicio = aux[i].length();
	            	Log.i("log","inicio: "+inicio);
	            	ret=ret.substring(inicio+3,ret.length());
	            	
	            	peticionesAmigos[i] = aux[i].split("x");
	             	Log.i("log_Usuarios", "id: " + peticionesAmigos[i][0] + " mensaje: " + peticionesAmigos[i][1]);
	             	
	            	Log.i("log", ret);
	            	indice = ret.indexOf(",");
	            	i++;
	            }
	            
	            Log.i("TratamientoFinal", ret);
	         	Log.i("TratamientoFinal", "tamaño cadena: " + ret.length());
	         	aux[i] = ret.substring(ret.indexOf("\"")+1, ret.indexOf("]")-1);
	         	Log.i("TratamientoFinal", aux[i]);
	         	inicio = aux[i].length();
	         	Log.i("TratamientoFinal","inicio: "+inicio);
	         	ret=ret.substring(inicio,ret.length());
	         	
	         	peticionesAmigos[i] = aux[i].split("x");
	         	Log.i("log_Usuarios", "id: " + peticionesAmigos[i][0] + " mensaje: " + peticionesAmigos[i][1]);
	         	i++;
	         	Log.i("logRestanteCadena", "contador=" + i + " resto de la cadena " + ret);
	     	}
	     	peticionesAmigos[i][0]="-1";
     	} 	
     	
     	
		
		return peticionesAmigos;
    	
    	
    }
    
    private int muestraDialogoSolicitudesPendientes(final String pet [][]){
    	
    	
		Log.i("MapitaAmistad", "hay peticiones de amistad? " + !pet[0][0].equals("-1"));
		int cont=0;
		
		AlertDialog.Builder constructor = new AlertDialog.Builder(ActividadMapa.this);
		Log.i("LogAlertDialogPeticionesAmistad", "creamos alertdialog.builder");
		constructor.setCancelable(false);

		Log.i("LogAlertDialogPeticionesAmistad", "creamos alertdialog, hay peticiones?idPeticionario: " + pet[cont][0]);
		LayoutInflater inflater = LayoutInflater.from(ActividadMapa.this);
		View v = inflater.inflate(R.layout.interfaz_dialogo_peticiones_amistad, null);
		constructor.setTitle("Tiene peticiones de amistad sin responder");
		constructor.setView(v);
		
		final AlertDialog dialogoPeticiones = constructor.create();
		dialogoPeticiones.setCanceledOnTouchOutside(false);
		
		if (!pet[cont][0].equals("-1"))
			dialogoPeticiones.show();
		Button btonCerrar = (Button) dialogoPeticiones.findViewById(R.id.ButtonCerrarPeticionAmistad);
		
		while (!pet[cont][0].equals("-1") && cont <= 5){
			Log.i("LogAlertDialogPeticionesAmistad", "entramos en while, hay peticiones?idPeticionario: " + pet[cont][0]);
			
			
			switch (cont){
				case 0:
					final TextView textPeticionAmistad0 = (TextView) dialogoPeticiones.findViewById(R.id.TextPeticionAmistad0);
					final Button botonAceptar0 = (Button) dialogoPeticiones.findViewById(R.id.ButtonAceptarPeticionAmistad0);
					final Button botonCancelar0 = (Button) dialogoPeticiones.findViewById(R.id.ButtonCancelarPeticionAmistad0);
					final int contador0 = cont;
					Log.i("LogAlertDialogPeticionesAmistad", "creado textview0");
					textPeticionAmistad0.setText(pet[contador0][1]);
					Log.i("LogAlertDialogPeticionesAmistad", "puesto texto0");
					botonAceptar0.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							
							if(esAmigo(idUsuario, pet[contador0][0]).equals("false")){
								if(añadeAmigoId(idUsuario, pet[contador0][0]).equals("ok")){
									textPeticionAmistad0.setText(R.string.aceptaPeticion);
									Toast.makeText(ActividadMapa.this, R.string.amigoExito, Toast.LENGTH_LONG).show();
								}else
									Toast.makeText(ActividadMapa.this, R.string.amigoNoExito, Toast.LENGTH_LONG).show();
							}else
								Toast.makeText(ActividadMapa.this, R.string.yaEsAmigo, Toast.LENGTH_LONG).show();
							textPeticionAmistad0.setText(R.string.aceptaPeticion);
							botonAceptar0.setVisibility(View.GONE);
							botonCancelar0.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botonAceptar0");
					botonCancelar0.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							textPeticionAmistad0.setText(R.string.rechazaPeticion);
							botonAceptar0.setVisibility(View.GONE);
							botonCancelar0.setVisibility(View.GONE);
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botonCancelar0");
					break;
				case 1:
					final TextView textPeticionAmistad1 = (TextView) dialogoPeticiones.findViewById(R.id.TextPeticionAmistad1);
					final Button botonAceptar1 = (Button) dialogoPeticiones.findViewById(R.id.ButtonAceptarPeticionAmistad1);
					final Button botonCancelar1 = (Button) dialogoPeticiones.findViewById(R.id.ButtonCancelarPeticionAmistad1);
					final int contador1 = cont;
					botonAceptar1.setVisibility(View.VISIBLE);
					botonCancelar1.setVisibility(View.VISIBLE);
					textPeticionAmistad1.setVisibility(View.VISIBLE);
					Log.i("LogAlertDialogPeticionesAmistad", "creado textview1");
					textPeticionAmistad1.setText(pet[contador1][1]);
					Log.i("LogAlertDialogPeticionesAmistad", "puesto texto1");
					botonAceptar1.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							
							if(esAmigo(idUsuario, pet[contador1][0]).equals("false")){
								if(añadeAmigoId(idUsuario, pet[contador1][0]).equals("ok")){
									textPeticionAmistad1.setText(R.string.aceptaPeticion);
									Toast.makeText(ActividadMapa.this, R.string.amigoExito, Toast.LENGTH_LONG).show();
								}else
									Toast.makeText(ActividadMapa.this, R.string.amigoNoExito, Toast.LENGTH_LONG).show();
								
							}else
								Toast.makeText(ActividadMapa.this, R.string.yaEsAmigo, Toast.LENGTH_LONG).show();
							textPeticionAmistad1.setText(R.string.aceptaPeticion);
							botonAceptar1.setVisibility(View.GONE);
							botonCancelar1.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botonaceptar1");
					botonCancelar1.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							textPeticionAmistad1.setText(R.string.rechazaPeticion);
							botonAceptar1.setVisibility(View.GONE);
							botonCancelar1.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botoncancelar1");
					break;
				case 2:
					final TextView textPeticionAmistad2 = (TextView) dialogoPeticiones.findViewById(R.id.TextPeticionAmistad2);
					final Button botonAceptar2 = (Button) dialogoPeticiones.findViewById(R.id.ButtonAceptarPeticionAmistad2);
					final Button botonCancelar2 = (Button) dialogoPeticiones.findViewById(R.id.ButtonCancelarPeticionAmistad2);
					final int contador2 = cont;
					botonAceptar2.setVisibility(View.VISIBLE);
					botonCancelar2.setVisibility(View.VISIBLE);
					textPeticionAmistad2.setVisibility(View.VISIBLE);
					Log.i("LogAlertDialogPeticionesAmistad", "creado textview2");
					textPeticionAmistad2.setText(pet[contador2][1]);
					Log.i("LogAlertDialogPeticionesAmistad", "puesto texto2");
					botonAceptar2.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							
							if(esAmigo(idUsuario, pet[contador2][0]).equals("false")){
								if(añadeAmigoId(idUsuario, pet[contador2][0]).equals("ok")){
									textPeticionAmistad2.setText(R.string.aceptaPeticion);
									Toast.makeText(ActividadMapa.this, R.string.amigoExito, Toast.LENGTH_LONG).show();
								}else
									Toast.makeText(ActividadMapa.this, R.string.amigoNoExito, Toast.LENGTH_LONG).show();
							}else
								Toast.makeText(ActividadMapa.this, R.string.yaEsAmigo, Toast.LENGTH_LONG).show();
							textPeticionAmistad2.setText(R.string.aceptaPeticion);
							botonAceptar2.setVisibility(View.GONE);
							botonCancelar2.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botonaceptar2");
					botonCancelar2.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							textPeticionAmistad2.setText(R.string.rechazaPeticion);
							botonAceptar2.setVisibility(View.GONE);
							botonCancelar2.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botoncancelar2");
					break;
				case 3:
					final TextView textPeticionAmistad3 = (TextView) dialogoPeticiones.findViewById(R.id.TextPeticionAmistad3);
					final Button botonAceptar3 = (Button) dialogoPeticiones.findViewById(R.id.ButtonAceptarPeticionAmistad3);
					final Button botonCancelar3 = (Button) dialogoPeticiones.findViewById(R.id.ButtonCancelarPeticionAmistad3);
					final int contador3 = cont;
					botonAceptar3.setVisibility(View.VISIBLE);
					botonCancelar3.setVisibility(View.VISIBLE);
					textPeticionAmistad3.setVisibility(View.VISIBLE);
					Log.i("LogAlertDialogPeticionesAmistad", "creado textview3");
					textPeticionAmistad3.setText(pet[contador3][1]);
					Log.i("LogAlertDialogPeticionesAmistad", "puesto texto3");
					botonAceptar3.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							
							if(esAmigo(idUsuario, pet[contador3][0]).equals("false")){
								if(añadeAmigoId(idUsuario, pet[contador3][0]).equals("ok")){
									textPeticionAmistad3.setText(R.string.aceptaPeticion);
									Toast.makeText(ActividadMapa.this, R.string.amigoExito, Toast.LENGTH_LONG).show();
								}else
									Toast.makeText(ActividadMapa.this, R.string.amigoNoExito, Toast.LENGTH_LONG).show();
							}else
								Toast.makeText(ActividadMapa.this, R.string.yaEsAmigo, Toast.LENGTH_LONG).show();
							textPeticionAmistad3.setText(R.string.aceptaPeticion);
							botonAceptar3.setVisibility(View.GONE);
							botonCancelar3.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botonaceptar3");
					botonCancelar3.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							textPeticionAmistad3.setText(R.string.rechazaPeticion);
							botonAceptar3.setVisibility(View.GONE);
							botonCancelar3.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botoncancelar3");
					break;
				case 4:
					final TextView textPeticionAmistad4 = (TextView) dialogoPeticiones.findViewById(R.id.TextPeticionAmistad4);
					final Button botonAceptar4 = (Button) dialogoPeticiones.findViewById(R.id.ButtonAceptarPeticionAmistad4);
					final Button botonCancelar4 = (Button) dialogoPeticiones.findViewById(R.id.ButtonCancelarPeticionAmistad4);
					final int contador4 = cont;
					botonAceptar4.setVisibility(View.VISIBLE);
					botonCancelar4.setVisibility(View.VISIBLE);
					textPeticionAmistad4.setVisibility(View.VISIBLE);
					Log.i("LogAlertDialogPeticionesAmistad", "creado textview4");
					textPeticionAmistad4.setText(pet[contador4][1]);
					Log.i("LogAlertDialogPeticionesAmistad", "puesto texto4");
					botonAceptar4.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							
							if(esAmigo(idUsuario, pet[contador4][0]).equals("false")){
								if(añadeAmigoId(idUsuario, pet[contador4][0]).equals("ok")){
									Toast.makeText(ActividadMapa.this, R.string.amigoExito, Toast.LENGTH_LONG).show();
									textPeticionAmistad4.setText(R.string.aceptaPeticion);
								}else
									Toast.makeText(ActividadMapa.this, R.string.amigoNoExito, Toast.LENGTH_LONG).show();
							}else
								Toast.makeText(ActividadMapa.this, R.string.yaEsAmigo, Toast.LENGTH_LONG).show();
							
							botonAceptar4.setVisibility(View.GONE);
							botonCancelar4.setVisibility(View.GONE);
							
						}
					});Log.i("LogAlertDialogPeticionesAmistad", "creado botonaceptar4");
					botonCancelar4.setOnClickListener(new OnClickListener() {
						
						public void onClick(View v) {
							textPeticionAmistad4.setText(R.string.rechazaPeticion);
							botonAceptar4.setVisibility(View.GONE);
							botonCancelar4.setVisibility(View.GONE);
							
						}
					});
					Log.i("LogAlertDialogPeticionesAmistad", "creado botoncancelar4");
					break;			
			}
			cont++;
		}
		btonCerrar.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				dialogoPeticiones.dismiss();
				
			}
		});
		
    	Log.i("PeticionesAmistad", "hay " + cont + " solicitudes pendientes." );
		return cont;
    	
    }
    
    
    public static void enviaMensaje(String idUser, String mensaje){

    	mensaje = str_replace(" ", "_", mensaje);
		final String URLMensaje = "http://aperezba.dyndns.org:9080/webService/MandarSmsAction.action?parametroJSON=" + idUsuario + "xx" + idUser + "xx" + mensaje;
		
		
		
		Log.i("envio mensaje", "URL: " + URLMensaje);
		
		try {
			
			URLEncoder.encode(URLMensaje, "UTF-8");
		} catch (UnsupportedEncodingException e1) {

			e1.printStackTrace();
		}
		
		Log.i("envio mensaje", "URL Encode: " + URLMensaje);
		
		HttpClient httpclient = new DefaultHttpClient();
    	//Seteamos nuestro servidor que recibirá las variables Post
    	 Log.i("envio mensaje", "por aki por aki");
    	 
    	 HttpPost httppost = new HttpPost(URLMensaje);
    	 Log.i("envio mensaje", "por aki por aki2");
    	 

		try {
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
		    Log.i("envio mensaje", "por aki por aki3");
		
    	//agregamos datos a mi lista
    	    nameValuePairs.add(new BasicNameValuePair("Tu_variable", "0.0"));
    	    Log.i("envio mensaje", "por aki por aki4");
    	
    	      
    	//Contruimos el pack de datos
    	    httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
    	    Log.i("envio mensaje", "por aki por aki5");
    	
    	         
    	          

    	//Ejecutamos la instrucciones de httpPost
    	       
    	    HttpResponse response = httpclient.execute(httppost);
    	    Log.i("envio mensaje", "por aki por aki6: " + response + ". Que en humano sería: " + response.toString());
    	  
    	      
    	    } catch (ClientProtocolException e) {
    	    	Log.i("fallito pixa", "eso");
    	    } catch (IOException e) {
    	    	Log.i("fallito pixa", "lo otro");
    	     }

	}
    
    private void muestraDialogoMensajes(String usuarioReceptor) {
    	
    	AlertDialog.Builder constructor = new AlertDialog.Builder(ActividadMapa.this);
		Log.i("LogAlertDialogMensajes", "creamos alertdialog.builder");
		constructor.setCancelable(true);

		Log.i("LogAlertDialogMensajes", "creamos alertdialog, hay peticiones?idPeticionario: ");
		LayoutInflater inflater = LayoutInflater.from(ActividadMapa.this);
		View v = inflater.inflate(R.layout.interfaz_dialogo_mensajes, null);
		constructor.setView(v);
		
		final AlertDialog dialogoMensajes = constructor.create();
		dialogoMensajes.setCanceledOnTouchOutside(true);
		dialogoMensajes.show();
		
		
		ImageView recibidos = (ImageView) dialogoMensajes.findViewById(R.id.BotonMensajesRecibidos);
		ImageView enviados = (ImageView) dialogoMensajes.findViewById(R.id.BotonMensajesEnviados);
		ImageView nuevos = (ImageView) dialogoMensajes.findViewById(R.id.BotonNuevosMensajes);
		
		recibidos.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				Toast.makeText(ActividadMapa.this, R.string.cargandoMensajes, Toast.LENGTH_LONG).show();
				
				Intent mensajesRecibidos = new Intent(ActividadMapa.this, ActividadMensajesRecibidos.class);
				mensajesRecibidos.putExtra("idUser", idUsuario);
				startActivity(mensajesRecibidos);
				
			}
		});
		enviados.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				Toast.makeText(ActividadMapa.this, R.string.cargandoMensajes, Toast.LENGTH_LONG).show();
				
				Intent mensajesEnviados = new Intent(ActividadMapa.this, ActividadMensajesEnviados.class);
				mensajesEnviados.putExtra("idUser", idUsuario);
				startActivity(mensajesEnviados);
			}
		});
		nuevos.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				Toast.makeText(ActividadMapa.this, R.string.cargandoMensajes, Toast.LENGTH_LONG).show();
				
				Intent mensajesNuevos = new Intent(ActividadMapa.this, ActividadMensajesNuevos.class);
				mensajesNuevos.putExtra("idUser", idUsuario);
				startActivity(mensajesNuevos);
				
			}
		});
		Button botonCerrar = (Button) dialogoMensajes.findViewById(R.id.ButtonCerrarMensajes);
		botonCerrar.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				dialogoMensajes.dismiss();	
			}
		});
	}
    
    //Función que sustituye la cadena 'search' con 'replace' en la cadena original 'subject'
    public static String str_replace (String search, String replace, String subject){
      StringBuffer  result = new StringBuffer (subject);
      int  pos = 0;
      while (true)
      {
        pos = result.indexOf (search, pos);
        if (pos != -1)
          result.replace (pos, pos + search.length (), replace);
        else
          break;
      }
      return result.toString ();
    }
    
	
    @Override
	public void onPause(){
		Log.i("Pauseeeeeeeeeeeeeeeer", "hemos entrao aquí");
		super.onPause();
		
	}
	
	public void onSaveInstanceState(Bundle savedInstanceState){
		savedInstanceState.putString("usuario", nickNameUsuario);
		
		super.onSaveInstanceState(savedInstanceState);
	}
	
	public void onRestoreInstanceState(Bundle savedInstanceState){
		super.onRestoreInstanceState(savedInstanceState);
		
		Log.i("LOdelasInstanciasQUITAR", "usuario" + nickNameUsuario);
		
	}
	

	public void onDestroy() {
		Log.i("Destroyeeeeeer", "hemos entrao aquí");
		desconecta(idUsuario);
		mMapa.destroyDrawingCache();
		mMapOverlays.clear();
		mMiPosicion.disableMyLocation();
		mLocationControl.removeUpdates(mLocationListener);
		Servicio.activo = false;
		Log.i("Destroyeeeeeer", "vamos a salir de aquí");
		super.onDestroy();
	}
	
}
