package com.pfc.app.nbff;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.IBinder;
import android.os.SystemClock;
import android.util.Log;


public class Servicio extends Service {

	private static final int INTERVALO=500000; //5 minutos de intervalo

	private static Notificaciones abreMapa;
	static long i=0;
	private static String cadenaConexion;
	private static Timer timer = new Timer();
	public static Context contexto;
	public static boolean activo = false;

	
	@Override

	public void onCreate() {

		super.onCreate();
		contexto = getBaseContext();
		
	}

	public static void setMainActivity() {

		Log.i("Servicio", "dentro de servicio");

		_startService();

		Log.i("Servicio", "servicio lanzado");
		SystemClock.sleep(10000);

	}

	@Override

	public IBinder onBind(Intent intent) {

		return(null);

	}

	@Override

	public void onDestroy() {

		super.onDestroy();

	}

	public static void update(){

		Date date = new Date();
		activo = true;
		i++;
		Log.i("Servicio", "dentro de update, contador:  " + i + " : "+ date.toGMTString());
		
				
		//abreMapa.t.setText( i + ":"+ date.toGMTString()  );
		if (i<12){
			
			cadenaConexion = ActividadMapa.conectarListaUsuarios(contexto);
			Log.i("Servicio", "creada cadena de conexión");
			String cadAux= ActividadMapa.buscaAmigos(cadenaConexion);
			String usuarios[][] = ActividadMapa.desencriptaUsuarios(cadAux);
			Log.i("Servicio", "creada cadena de conexión: " + ActividadMapa.numeroUsuariosApintar);
			if(ActividadMapa.numeroUsuariosApintar>0){
				ActividadMapa.dibujarAmigos(usuarios,ActividadMapa.numeroUsuariosApintar);
				Log.i("Servicio", "buscaAmigos lanzado");
			}
		}else{
			
		}

	}

	private static void _startService() {

		  timer.scheduleAtFixedRate(

		      new TimerTask() {

		        public void run() {

		        	update();			

		        }

		      },

		      0,

		      INTERVALO);

		}	

}