package com.pfc.app.nbff;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class AndroidClient {

    private URL m_cURL = null;
    private HttpURLConnection m_cConn = null;




  public String connectToServer(){
        try {
            m_cURL = new URL("http://aperezba.dyndns.org:9080/index.action");
            if(null == m_cConn){
                m_cConn = (HttpURLConnection) m_cURL.openConnection();
                m_cConn.setDoOutput(true);
                m_cConn.setDoInput(true);
            }
            return "true";
        }catch (Exception e) {
            return ("Connection Error::"+e);
        }
    }

    public String fetchUserDetails(String userID){
        DataOutputStream dos = null;
        InputStream is = null;
        String responseUserDetails = null;
        String cadena = "cagada máxima";
        try {
            String cts = connectToServer();
            
            if (cts == "true"){
	            
	            String uID="yourId";
	            dos = new DataOutputStream(m_cConn.getOutputStream());
	            dos.write(uID.getBytes(), 0, uID.getBytes().length);
	
	            is = m_cConn.getInputStream();
	            StringBuilder sb = new StringBuilder();
	            String line;
	
	            BufferedReader reader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
	            while ((line = reader.readLine()) != null) {
	                sb.append(line);
	            }
	            responseUserDetails = sb.toString();
	            cadena = "Response Text(Fetch): " + responseUserDetails;
            }
            return cadena;
        } catch (Exception e) {
            return responseUserDetails;
        } finally{
                try{
                    if (is != null) 
                        is.close(); 
                    if (dos != null){
                        dos.flush();    
                        dos.close();
                    }
                    disconnectServer();
                }catch(Exception pEx){
                    System.out.println(pEx.toString());
                	return "fallofallofallo";
            }
        }
        
    }

    public void disconnectServer(){
        try {
            m_cConn.disconnect();
            m_cConn = null;
        }catch (Exception e) {
            System.out.println("Connection Error::"+e);
        }
    }

	
	
	
}
